#ifndef JPGOPTDIALOG_H_INC
#define JPGOPTDIALOG_H_INC

#include "dialog.h"

class JpgOptionsDialogClass : public ModalDialogClass
{
public:

   JpgOptionsDialogClass(HWND aParentWnd)
   {
      Parent = aParentWnd;
      Quality = 0;
   }
   virtual ~JpgOptionsDialogClass()
   {

   }
   UINT Run()
   {
      return ModalDialogClass::DoDialog(this, Parent, IDD_JPG_OPTIONS_DIALOG);
   }

   virtual void OnInitDialog()
   {
      SendDlgItemMessage(IDC_JPG_OPT_SPIN, TBM_SETRANGE, TRUE, MakeLong(1, 100));
      SendDlgItemMessage(IDC_JPG_OPT_SPIN, TBM_SETPOS, TRUE, 80);
      SendDlgItemMessage(IDC_JPG_OPT_SPIN, TBM_SETTICFREQ, 10, 0);
      SetDlgItemInt(IDC_JPG_OPT_QUALITY, 80);
   }
   virtual void OnHScroll(uint16_t aCode, uint16_t aPos, HWND aCtrlHWnd)
   {  // From the slider ...
      switch(aCode)
      {
      case SB_THUMBPOSITION:
      // case SB_ENDSCROLL:
      case SB_THUMBTRACK:
      {
         int32_t pos = SendDlgItemMessage(IDC_JPG_OPT_SPIN, TBM_GETPOS, 0, 0);
         if(pos > 100)
            pos = 100;
         else if(pos < 1)
            pos = 1;
         SetDlgItemInt(IDC_JPG_OPT_QUALITY, aPos);
         break;
      }
      }
   }

   virtual bool OnClose(UINT aMsg)
   {
      if(aMsg == IDOK)
         Quality = SendDlgItemMessage(IDC_JPG_OPT_SPIN, TBM_GETPOS, 0, 0);

      return TRUE;
   }
   virtual bool OnCommand(UINT aId, UINT aMsg, HWND aCtrlHwnd)
   {
      return true;
   }
   int32_t GetQuality() { return Quality; }
private:
   HWND Parent;
   uint32_t Quality;
};

#endif
